/**************************************************************************/
/*   Picture compressor par Purobaz                                      */
/*   Reduit la taille des pictures basics                                */
/*                                                                       */
/*   Remerciements a Dafp pour ses recherches et ses explications        */
/*   Et a Pierrotll pour tout le code que j'ai recupere                  */
/*                                                                       */
/*************************************************************************/

#include "fxlib.h"
#include "explorer.h"
#include "special_chars.h"


void write(char* name)
{
	int file, size = 1024, pos, key=1, i, j;
	char line[13] = {CHAR_MB1_BIG_ARROW_LEFT, CHAR_MB2_BIG_ARROW_LEFT,0};
	FONTCHARACTER filename[20] = {'\\','\\','f','l','s','0','\\'};
	char header[77] = {0};
	char * content;
	
	do {
		pos = 2;
		j = size;
		for(i=j ; i ; i/=10) pos++;
		line[pos] = CHAR_MB1_BIG_ARROW_RIGHT;
		line[pos+1] = CHAR_MB2_BIG_ARROW_RIGHT;
		for(i=11 ; i>=pos+2 ; i--) line[i] = 0;
        for( ; j ; j/=10) line[--pos] = j%10+'0';
		
		PopUpWin(4);
		locate(6, 3); Print("Select size");
		locate(6, 5); Print(line);
		Print(" octets");
		GetKey(&key);
		switch(key) {
			case KEY_CTRL_LEFT: {
				size -= 16;
				if(size < 16) size = 1024;
				}
				break;
			case KEY_CTRL_RIGHT: {
				size += 16;
				if(size > 1024) size = 16;
				}
				break;
			case KEY_CTRL_EXE:
				key = 0;
		}
	}while(key);
	
	
	content = (char*)malloc((size+1)*sizeof(char));
	
	for(i=0 ; name[i] ; i++)
		filename[7+i] = name[i];
	
	file = Bfile_OpenFile(filename, _OPENMODE_READ);
	if(file >= 0) {
		Bfile_ReadFile(file, &header, 76, 0);
		if(size < 1024) {
			Bfile_ReadFile(file, content, size, 92);
			content[0]&=0x7F;
		}
		else Bfile_ReadFile(file, content, size, -1);
		Bfile_CloseFile(file);
	
		//taille fichier
		header[14]=(0xFF-(unsigned short)((size+141)%256))&0xFF;
		header[18]=(0xFF-(unsigned short)((size+76)/256))&0xFF;
		header[19]=(0xFF-(unsigned short)((size+76)%256))&0xFF;
		header[20]=(0xFF-(unsigned short)((size+4)%256))&0xFF;
		//taille picture
		header[71]=((unsigned short)(size/256))&0xFF;
		header[72]=((unsigned short)(size%256))&0xFF;
		
		Bfile_DeleteFile(filename);
		Bfile_CreateFile(filename, size+76);
		file = Bfile_OpenFile(filename, _OPENMODE_WRITE);
		if(file >= 0) {
			Bfile_WriteFile(file, &header, 76);
			Bfile_WriteFile(file, content, size);
			Bfile_CloseFile(file);
			PopUpWin(4);
			locate(7, 3);
			Print("Complete!");
			locate(6, 5);
			Print("Press:[EXIT]");
			while(key != KEY_CTRL_EXIT) GetKey(&key);
		}
	}
	free(content);
	return;
}


int AddIn_main(int isAppli, unsigned short OptionNum)
{
	char name[13];
	int i;
	while(1) {
		for(i=0 ; i<13 ; i++) name[i] = 0;
		explorer(name);
		write(name);
	}

    return 1;
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

